VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "clsConnectionEnum"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "SavedWithClassBuilder" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"No"
' ------------------------------------------------------
' ConnectionEnum.CLS
' Copyright (c) Slightly Tilted Software 1999
' By: L.J. Johnson       Date: 04-26-1999
' Comments: Individual collection item managed via
'           colConnectionEnum collection class
' NOTE: Public-not-Creatable
' ------------------------------------------------------
Option Explicit
Option Base 1
Option Compare Text
DefLng A-Z

' --------------------------------------------
' Private variable(s) to hold data for public
'     properties
' --------------------------------------------
Private m_enmConnectionType            As enumShareType
Private m_lngConnectionID              As Long
Private m_lngNumOpens                  As Long
Private m_lngNumUsers                  As Long
Private m_lngConnectionTime            As Long
Private m_strConnectTimeFormatted      As String
Private m_strUserName                  As String
Private m_strNetName                   As String

' *******************************************************
' Routine Name : (FRIEND in CLASS) Sub Init
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Writen  : 04/26/1999 -- 12:13:59
' Inputs       : ByVal xi_enmConnectionType:enumShareType -
'              : ByVal xi_lngConnectionID:Long -
'              : ByVal xi_lngNumOpens:Long -
'              : ByVal xi_lngNumUsers:Long -
'              : ByVal xi_lngConnectionTime:Long -
'              : ByVal xi_strConnectTimeFormatted:String -
'              : ByVal xi_strUserName:String -
'              : ByVal xi_strNetName:String -
' Outputs      : N/A
' Description  : Since all the properties are Read-Only,
'              :     you **MUST** call the Init function
'              :     to fill in the public properties
' *******************************************************
Friend Sub Init(ByVal xi_enmConnectionType As enumShareType, _
                ByVal xi_lngConnectionID As Long, _
                ByVal xi_lngNumOpens As Long, _
                ByVal xi_lngNumUsers As Long, _
                ByVal xi_lngConnectionTime As Long, _
                ByVal xi_strConnectTimeFormatted As String, _
                ByVal xi_strUserName As String, _
                ByVal xi_strNetName As String)

   m_enmConnectionType = xi_enmConnectionType
   m_lngConnectionID = xi_lngConnectionID
   m_lngNumOpens = xi_lngNumOpens
   m_lngNumUsers = xi_lngNumUsers
   m_lngConnectionTime = xi_lngConnectionTime
   m_strConnectTimeFormatted = xi_strConnectTimeFormatted
   m_strUserName = xi_strUserName
   m_strNetName = xi_strNetName
   
End Sub

' *******************************************************
' Routine Name : (PUBLIC in CLASS) Property Get ConnectTimeFormatted
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Writen  : 04/26/1999 -- 12:17:23
' Inputs       : N/A
' Outputs      : String --
' Description  : Read-only public property
' *******************************************************
Public Property Get ConnectTimeFormatted() As String
   ConnectTimeFormatted = m_strConnectTimeFormatted
End Property

' *******************************************************
' Routine Name : (PUBLIC in CLASS) Property Get ConnectionType
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Writen  : 04/26/1999 -- 12:17:19
' Inputs       : N/A
' Outputs      : enumShareType --
' Description  : Read-only public property
' *******************************************************
Public Property Get ConnectionType() As enumShareType
   ConnectionType = m_enmConnectionType
End Property

' *******************************************************
' Routine Name : (PUBLIC in CLASS) Property Get ConnectionID
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Writen  : 04/26/1999 -- 12:17:16
' Inputs       : N/A
' Outputs      : Long --
' Description  : Read-only public property
' *******************************************************
Public Property Get ConnectionID() As Long
   ConnectionID = m_lngConnectionID
End Property

' *******************************************************
' Routine Name : (PUBLIC in CLASS) Property Get NumOpens
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Writen  : 04/26/1999 -- 12:17:14
' Inputs       : N/A
' Outputs      : Long --
' Description  : Read-only public property
' *******************************************************
Public Property Get NumOpens() As Long
   NumOpens = m_lngNumOpens
End Property

' *******************************************************
' Routine Name : (PUBLIC in CLASS) Property Get NumUsers
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Writen  : 04/26/1999 -- 12:16:56
' Inputs       : N/A
' Outputs      : Long --
' Description  : Read-only public property
' *******************************************************
Public Property Get NumUsers() As Long
   NumUsers = m_lngNumUsers
End Property

' *******************************************************
' Routine Name : (PUBLIC in CLASS) Property Get ConnectionTime
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Writen  : 04/26/1999 -- 12:17:02
' Inputs       : N/A
' Outputs      : Long --
' Description  : Read-only public property
' *******************************************************
Public Property Get ConnectionTime() As Long
   ConnectionTime = m_lngConnectionTime
End Property

' *******************************************************
' Routine Name : (PUBLIC in CLASS) Property Get UserName
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Writen  : 04/26/1999 -- 12:16:53
' Inputs       : N/A
' Outputs      : String --
' Description  : Read-only public property
' *******************************************************
Public Property Get UserName() As String
   UserName = m_strUserName
End Property

' *******************************************************
' Routine Name : (PUBLIC in CLASS) Property Get NetName
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Writen  : 04/26/1999 -- 12:16:51
' Inputs       : N/A
' Outputs      : String --
' Description  : Read-only public property
' *******************************************************
Public Property Get NetName() As String
   NetName = m_strNetName
End Property
