VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "clsFileEnum"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "SavedWithClassBuilder" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"No"
' ------------------------------------------------------
' FileEnum.CLS
' Copyright (c) Slightly Tilted Software 1999
' By: L.J. Johnson       Date: 04-26-1999
' Comments: Individual collection item managed via
'           colFileEnum collection class
' NOTE: Public-not-Creatable
' ------------------------------------------------------
Option Explicit
Option Base 1
Option Compare Text
DefLng A-Z

' --------------------------------------------
' Private variable(s) to hold data for public
'     properties
' --------------------------------------------
Private m_lngID                        As Long
Private m_lngPermissions               As enumFilePermissions
Private m_lngNumLocks                  As Long
Private m_strPathName                  As String
Private m_strUserName                  As String

' --------------------------------------------
' Public enum (exposed to client)
' --------------------------------------------
Public Enum enumFilePermissions
   PERM_FILE_READ = 1&
   PERM_FILE_WRITE = 2&
   PERM_FILE_CREATE = 4&
   PERM_FILE_EXECUTE = 8&
   ACCESS_DELETE = 16&
   ACCESS_ATRIB = 32&
   ACCESS_PERM = 64&
End Enum

' *******************************************************
' Routine Name : (FRIEND in CLASS) Sub Init
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Writen  : 04/26/1999 -- 12:15:36
' Inputs       : ByVal xi_lngID:Long -
'              : ByVal xi_enmFilePermissions:enumFilePermissions -
'              : ByVal xi_lngNumLocks:Long -
'              : ByVal xi_strPathName:String -
'              : ByVal xi_strUserName:String -
' Outputs      : N/A
' Description  : Since all the properties are Read-Only,
'              :     you **MUST** call the Init function
'              :     to fill in the public properties
' *******************************************************
Friend Sub Init(ByVal xi_lngID As Long, _
                ByVal xi_enmFilePermissions As enumFilePermissions, _
                ByVal xi_lngNumLocks As Long, _
                ByVal xi_strPathName As String, _
                ByVal xi_strUserName As String)

   m_lngID = xi_lngID
   m_lngPermissions = xi_enmFilePermissions
   m_lngNumLocks = xi_lngNumLocks
   m_strPathName = xi_strPathName
   m_strUserName = xi_strUserName
   
End Sub

' *******************************************************
' Routine Name : (PUBLIC in CLASS) Property Get ID
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Writen  : 04/26/1999 -- 12:18:59
' Inputs       : N/A
' Outputs      : Long --
' Description  : Read-only public property
' *******************************************************
Public Property Get ID() As Long
   ID = m_lngID
End Property

' *******************************************************
' Routine Name : (PUBLIC in CLASS) Property Get Permissions
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Writen  : 04/26/1999 -- 12:18:56
' Inputs       : N/A
' Outputs      : enumFilePermissions --
' Description  : Read-only public property
' *******************************************************
Public Property Get Permissions() As enumFilePermissions
   Permissions = m_lngPermissions
End Property

' *******************************************************
' Routine Name : (PUBLIC in CLASS) Property Get NumberLocks
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Writen  : 04/26/1999 -- 12:18:53
' Inputs       : N/A
' Outputs      : Long --
' Description  : Read-only public property
' *******************************************************
Public Property Get NumberLocks() As Long
   NumberLocks = m_lngNumLocks
End Property

' *******************************************************
' Routine Name : (PUBLIC in CLASS) Property Get Pathname
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Writen  : 04/26/1999 -- 12:18:51
' Inputs       : N/A
' Outputs      : String --
' Description  : Read-only public property
' *******************************************************
Public Property Get PathName() As String
   PathName = m_strPathName
End Property

' *******************************************************
' Routine Name : (PUBLIC in CLASS) Property Get UserName
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Writen  : 04/26/1999 -- 12:18:48
' Inputs       : N/A
' Outputs      : String --
' Description  : Read-only public property
' *******************************************************
Public Property Get UserName() As String
   UserName = m_strUserName
End Property
