Attribute VB_Name = "modMain"
' ------------------------------------------------------
' Main.BAS
' Copyright (c) Slightly Tilted Software 1999
' By: L.J. Johnson       Date: 04-26-1999
' Comments: Contains functions that are public within
'           the DLL but not exposed externally
' ------------------------------------------------------
Option Explicit
Option Base 1
Option Compare Text
DefLng A-Z

' --------------------------------------------
' Used by all msgbox calls
' --------------------------------------------
Public Const g_constMsgTitle           As String = "Server Information Applet"

' --------------------------------------------
' One of the standard "errors" for net calls
' --------------------------------------------
Public Const NERR_Success              As Long = 0&

' --------------------------------------------
' CopyMem and friends
' --------------------------------------------
Public Declare Sub CopyMem _
   Lib "kernel32" Alias "RtlMoveMemory" _
   (pTo As Any, _
    uFrom As Any, _
    ByVal lSize As Long)
Public Declare Sub StrCopyW _
   Lib "kernel32" Alias "lstrcpyW" _
   (vDest As Any, _
    ByVal vSrc As Any)
Public Declare Function StrCopyA _
   Lib "kernel32" Alias "lstrcpyA" _
   (ByVal RetVal As String, _
    ByVal Ptr As Long) As Long
Public Declare Function StrLenW _
   Lib "kernel32" Alias "lstrlenW" _
   (ByVal Ptr As Long) As Long
Public Declare Function StrLenA _
   Lib "kernel32" Alias "lstrlenA" _
   (ByVal Ptr As Long) As Long

' --------------------------------------------
' Get name of current computer
' --------------------------------------------
Public Declare Function GetComputerName _
   Lib "kernel32" Alias "GetComputerNameA" _
   (ByVal lpBuffer As String, _
    nSize As Long) As Long

' --------------------------------------------
' Always need to free the buffers we use
' --------------------------------------------
Public Declare Function NetApiBufferFree _
   Lib "netapi32.dll" (ByVal _
   Ptr As Long) As Long

' --------------------------------------------
' NetServerSetInfo and NetServerGetInfo
' --------------------------------------------
Public Type SERVER_INFO_101
    sv101_platform_id                  As Long
    sv101_name                         As Long
    sv101_version_major                As Long
    sv101_version_minor                As Long
    sv101_type                         As Long
    sv101_comment                      As Long
End Type

Public Type Server_Info_1005
   sv1005_comment                      As Long
End Type
 
Public Declare Function NetServerGetInfo _
   Lib "netapi32.dll" _
   (ServerName As Byte, _
    ByVal Level As Long, _
    Buffer As Long) As Long

Public Declare Function NetServerSetInfo _
   Lib "netapi32.dll" _
   (ServerName As Byte, _
    ByVal Level As Long, _
    Buffer As Long, _
    ByVal ParmError As Long) As Long

' --------------------------------------------
' NetConnectionEnum
' --------------------------------------------
Public Type Connection_Info_1
   coni1_id                            As Long
   coni1_type                          As Long
   coni1_num_opens                     As Long
   coni1_num_users                     As Long
   coni1_time                          As Long
   coni1_username                      As Long
   coni1_netname                       As Long
End Type

Public Declare Function NetConnectionEnum _
   Lib "netapi32.dll" _
   (ServerName As Byte, _
    Qualifier As Byte, _
    ByVal Level As Long, _
    Buffer As Long, _
    ByVal PreMaxLen As Long, _
    EntriesRead As Long, _
    TotalEntries As Long, _
    Resume_Handle As Long) As Long

' --------------------------------------------
' NetFileClose
' --------------------------------------------
Public Declare Function NetFileClose _
   Lib "Netapi32" _
   (ServerName As Byte, _
    ByVal PtrFile As Long) As Long

' --------------------------------------------
' NetFileEnum
' --------------------------------------------
Public Type File_Info_3
   fi3_id                              As Long
   fi3_permissions                     As Long
   fi3_num_locks                       As Long
   fi3_pathname                        As Long
   fi3_username                        As Long
End Type

Public Declare Function NetFileEnum _
   Lib "Netapi32" _
   (ServerName As Byte, _
    BasePath As Byte, _
    UserName As Byte, _
    ByVal Level As Long, _
    BufPtr As Long, _
    ByVal PrefMaxLen As Long, _
    EntriesRead As Long, _
    TotalLenEntries As Long, _
    ResumeHwnd As Long) As Long

' --------------------------------------------
' NetSessionDel
' --------------------------------------------
Public Declare Function NetSessionDel _
   Lib "netapi32.dll" _
   (ServerName As Byte, _
    UncClientName As Byte, _
    UserName As Byte) As Long

' --------------------------------------------
' NetSessionEnum
' --------------------------------------------
Public Type Session_Info_502
   sesi502_cname                       As Long
   sesi502_username                    As Long
   sesi502_num_opens                   As Long
   sesi502_time                        As Long
   sesi502_idle_time                   As Long
   sesi502_user_flags                  As Long
   sesi502_cltype_name                 As Long
   sesi502_transport                   As Long
End Type

Public Declare Function NetSessionEnum _
   Lib "netapi32.dll" _
   (ServerName As Byte, _
    UncClientName As Byte, _
    UserName As Byte, _
    ByVal Level As Long, _
    Buffer As Long, _
    ByVal PreMaxLen As Long, _
    EntriesRead As Long, _
    TotalEntries As Long, _
    Resume_Handle As Long) As Long

' --------------------------------------------
' NetShareDel
' --------------------------------------------
Public Declare Function NetShareDel _
   Lib "netapi32.dll" _
   (ServerName As Byte, _
    NetName As Byte, _
    ByVal Reserved As Long) As Long

' --------------------------------------------
' NetShareEnum
' --------------------------------------------
Public Type Share_Info_2
   shi2_netname                        As Long
   shi2_type                           As Long
   shi2_remark                         As Long
   shi2_permissions                    As Long
   shi2_max_uses                       As Long
   shi2_current_uses                   As Long
   shi2_path                           As Long
   shi2_password                       As Long
End Type

Public Declare Function NetShareEnum _
   Lib "netapi32.dll" _
   (ServerName As Byte, _
    ByVal Level As Long, _
    Buffer As Long, _
    ByVal PreMaxLen As Long, _
    EntriesRead As Long, _
    TotalEntries As Long, _
    Resume_Handle As Long) As Long

' *******************************************************
' Routine Name : (PUBLIC in MODULE) Function ConvertSeconds
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Writen  : 04/26/1999 -- 11:29:28
' Inputs       : ByVal xi_lngSeconds:Long -
' Outputs      : String --
' Description  : Convert a long holding seconds into a
'              :     formatted time string ("hh:nn:ss")
' *******************************************************
Public Function ConvertSeconds(ByVal xi_lngSeconds As Long) As String
On Error Resume Next                   ' Don't accept an error here
   Dim p_lngNumSeconds                 As Long
   Dim p_lngNumHours                   As Long
   Dim p_lngNumMinutes                 As Long
   Dim p_strTime                       As String
   
   p_lngNumSeconds = xi_lngSeconds
   
   p_lngNumHours = p_lngNumSeconds \ (60& * 60&)
   p_strTime = Format$(p_lngNumHours, "00") & ":"
   
   p_lngNumSeconds = p_lngNumSeconds - (p_lngNumHours * (60& * 60&))
   
   p_lngNumMinutes = p_lngNumSeconds \ 60
   p_strTime = p_strTime & Format$(p_lngNumMinutes, "00") & ":"
   
   p_lngNumSeconds = p_lngNumSeconds - (p_lngNumMinutes * 60)
   p_strTime = p_strTime & Format$(p_lngNumSeconds, "00")
   
   ConvertSeconds = p_strTime
End Function

' *******************************************************
' Routine Name : (PUBLIC in MODULE) Function PointerToUnicodeStr
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Writen  : 04/26/1999 -- 11:30:25
' Inputs       : lpUnicodeStr:Long -
' Outputs      : String --
' Description  : Converts a pointer to a string into a
'              :     string
' *******************************************************
Public Function PointerToUnicodeStr(lpUnicodeStr As Long) As String
On Error Resume Next                   ' Don't accept an error here
   Dim Buffer()                        As Byte
   Dim nLen                            As Long
   
   If lpUnicodeStr Then
      nLen = StrLenW(lpUnicodeStr) * 2
      If nLen Then
         ReDim Buffer(0 To (nLen - 1)) As Byte
         
         ' ------------------------------------
         ' Copy the pointer to the buffer into
         '     the type array
         ' ------------------------------------
         CopyMem Buffer(0), ByVal lpUnicodeStr, nLen
         PointerToUnicodeStr = Buffer
      End If
   End If

End Function
