VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "clsSessionEnum"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "SavedWithClassBuilder" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"No"
' ------------------------------------------------------
' SessionEnum.CLS
' Copyright (c) Slightly Tilted Software 1999
' By: L.J. Johnson       Date: 04-26-1999
' Comments: Individual collection item managed via
'           colSessionEnum collection class
' NOTE: Public-not-Creatable
' ------------------------------------------------------
Option Explicit
Option Base 1
Option Compare Text
DefLng A-Z

' --------------------------------------------
' Private variable(s) to hold data for public
'     properties
' --------------------------------------------
Private m_strComputerName              As String
Private m_strUserName                  As String
Private m_strTransport                 As String
Private m_lngNumOpens                  As Long
Private m_lngActiveTime                As Long
Private m_lngIdleTime                  As Long
Private m_strActiveTimeFormatted       As String
Private m_strIdleTimeFormatted         As String
Private m_enmUserFlags                 As enumUserFlags

' --------------------------------------------
' Public enum (exposed to client)
' --------------------------------------------
Public Enum enumUserFlags
   SESS_GUEST = 1&
   SESS_NOENCRPTION = 2&
End Enum

' *******************************************************
' Routine Name : (FRIEND in CLASS) Sub Init
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Writen  : 04/26/1999 -- 12:16:18
' Inputs       : ByVal xi_strComputerName:String -
'              : ByVal xi_strUserName:String -
'              : ByVal xi_strTransport:String -
'              : ByVal xi_lngNumOpens:Long -
'              : ByVal xi_lngActiveTime:Long -
'              : ByVal xi_strActiveTimeFormatted:String -
'              : ByVal xi_lngIdleTime:Long -
'              : ByVal xi_strIdleTimeFormatted:String -
'              : ByVal xi_enmUserFlags:enumUserFlags -
' Outputs      : N/A
' Description  : Since all the properties are Read-Only,
'              :     you **MUST** call the Init function
'              :     to fill in the public properties
' *******************************************************
Friend Sub Init(ByVal xi_strComputerName As String, _
                ByVal xi_strUserName As String, _
                ByVal xi_strTransport As String, _
                ByVal xi_lngNumOpens As Long, _
                ByVal xi_lngActiveTime As Long, _
                ByVal xi_strActiveTimeFormatted As String, _
                ByVal xi_lngIdleTime As Long, _
                ByVal xi_strIdleTimeFormatted As String, _
                ByVal xi_enmUserFlags As enumUserFlags)

   m_strComputerName = xi_strComputerName
   m_strUserName = xi_strUserName
   m_strTransport = xi_strTransport
   m_lngNumOpens = xi_lngNumOpens
   m_lngActiveTime = xi_lngActiveTime
   m_lngIdleTime = xi_lngIdleTime
   m_enmUserFlags = xi_enmUserFlags
   m_strActiveTimeFormatted = xi_strActiveTimeFormatted
   m_strIdleTimeFormatted = xi_strIdleTimeFormatted
   
End Sub

' *******************************************************
' Routine Name : (PUBLIC in CLASS) Property Get ActiveTimeFormatted
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Writen  : 04/26/1999 -- 12:20:05
' Inputs       : N/A
' Outputs      : String --
' Description  : Read-only public property
' *******************************************************
Public Property Get ActiveTimeFormatted() As String
   ActiveTimeFormatted = m_strActiveTimeFormatted
End Property

' *******************************************************
' Routine Name : (PUBLIC in CLASS) Property Get IdleTimeFormatted
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Writen  : 04/26/1999 -- 12:20:03
' Inputs       : N/A
' Outputs      : String --
' Description  : Read-only public property
' *******************************************************
Public Property Get IdleTimeFormatted() As String
   IdleTimeFormatted = m_strIdleTimeFormatted
End Property

' *******************************************************
' Routine Name : (PUBLIC in CLASS) Property Get ComputerName
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Writen  : 04/26/1999 -- 12:19:58
' Inputs       : N/A
' Outputs      : String --
' Description  : Read-only public property
' *******************************************************
Public Property Get ComputerName() As String
   ComputerName = m_strComputerName
End Property

' *******************************************************
' Routine Name : (PUBLIC in CLASS) Property Get UserName
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Writen  : 04/26/1999 -- 12:19:55
' Inputs       : N/A
' Outputs      : String --
' Description  : Read-only public property
' *******************************************************
Public Property Get UserName() As String
   UserName = m_strUserName
End Property

' *******************************************************
' Routine Name : (PUBLIC in CLASS) Property Get Transport
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Writen  : 04/26/1999 -- 12:19:52
' Inputs       : N/A
' Outputs      : String --
' Description  : Read-only public property
' *******************************************************
Public Property Get Transport() As String
   Transport = m_strTransport
End Property

' *******************************************************
' Routine Name : (PUBLIC in CLASS) Property Get NumOpens
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Writen  : 04/26/1999 -- 12:19:50
' Inputs       : N/A
' Outputs      : Long --
' Description  : Read-only public property
' *******************************************************
Public Property Get NumOpens() As Long
   NumOpens = m_lngNumOpens
End Property

' *******************************************************
' Routine Name : (PUBLIC in CLASS) Property Get ActiveTime
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Writen  : 04/26/1999 -- 12:19:48
' Inputs       : N/A
' Outputs      : Long --
' Description  : Read-only public property
' *******************************************************
Public Property Get ActiveTime() As Long
   ActiveTime = m_lngActiveTime
End Property

' *******************************************************
' Routine Name : (PUBLIC in CLASS) Property Get IdleTime
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Writen  : 04/26/1999 -- 12:19:45
' Inputs       : N/A
' Outputs      : Long --
' Description  : Read-only public property
' *******************************************************
Public Property Get IdleTime() As Long
   IdleTime = m_lngIdleTime
End Property

' *******************************************************
' Routine Name : (PUBLIC in CLASS) Property Get UserFlags
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Writen  : 04/26/1999 -- 12:19:43
' Inputs       : N/A
' Outputs      : enumUserFlags --
' Description  : Read-only public property
' *******************************************************
Public Property Get UserFlags() As enumUserFlags
   UserFlags = m_enmUserFlags
End Property
