VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "clsShareEnum"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "SavedWithClassBuilder" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"No"
' ------------------------------------------------------
' ShareEnum.CLS
' Copyright (c) Slightly Tilted Software 1999
' By: L.J. Johnson       Date: 04-26-1999
' Comments: Individual collection item managed via
'           colShareEnum collection class
' NOTE: Public-not-Creatable
' ------------------------------------------------------
Option Explicit
Option Base 1
Option Compare Text
DefLng A-Z

' --------------------------------------------
' Private variable(s) to hold data for public
'     properties
' --------------------------------------------
Private m_strShareName                 As String
Private m_strRemarks                   As String
Private m_strPath                      As String
Private m_lngMaximumConnections        As Long
Private m_lngCurrentConnections        As Long
Private m_enmShareType                 As enumShareType
Private m_enmPermissions               As enumSharePermissions

' --------------------------------------------
' Public enum (exposed to client)
' --------------------------------------------
Public Enum enumSharePermissions
   ACCESS_READ = &H1&
   ACCESS_WRITE = &H2&
   ACCESS_CREATE = &H4&
   ACCESS_EXEC = &H8&
   ACCESS_DELETE = &H10&
   ACCESS_ATRIB = &H20&
   ACCESS_PERM = &H40&
   ACCESS_ALL = &H7F
End Enum

Public Enum enumShareType
   STYPE_DISKTREE = 0&
   STYPE_PRINTQ = 1&
   STYPE_DEVICE = 2&
   STYPE_IPC = 3&
End Enum

' *******************************************************
' Routine Name : (FRIEND in CLASS) Sub Init
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Writen  : 04/26/1999 -- 12:16:02
' Inputs       : ByVal xi_strShareName:String -
'              : ByVal xi_strRemarks:String -
'              : ByVal xi_strPath:String -
'              : ByVal xi_lngMaximumConnections:Long -
'              : ByVal xi_lngCurrentConnections:Long -
'              : ByVal xi_enmShareType:enumShareType -
'              : ByVal xi_enmPermissions:enumSharePermissions -
' Outputs      : N/A
' Description  : Since all the properties are Read-Only,
'              :     you **MUST** call the Init function
'              :     to fill in the public properties
' *******************************************************
Friend Sub Init(ByVal xi_strShareName As String, _
                ByVal xi_strRemarks As String, _
                ByVal xi_strPath As String, _
                ByVal xi_lngMaximumConnections As Long, _
                ByVal xi_lngCurrentConnections As Long, _
                ByVal xi_enmShareType As enumShareType, _
                ByVal xi_enmPermissions As enumSharePermissions)

   m_strShareName = xi_strShareName
   m_strRemarks = xi_strRemarks
   m_strPath = xi_strPath
   m_lngMaximumConnections = xi_lngMaximumConnections
   m_lngCurrentConnections = xi_lngCurrentConnections
   m_enmShareType = xi_enmShareType
   m_enmPermissions = xi_enmPermissions
   
End Sub

' *******************************************************
' Routine Name : (PUBLIC in CLASS) Property Get ShareName
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Writen  : 04/26/1999 -- 12:21:28
' Inputs       : N/A
' Outputs      : String --
' Description  : Read-only public property
' *******************************************************
Public Property Get ShareName() As String
   ShareName = m_strShareName
End Property

' *******************************************************
' Routine Name : (PUBLIC in CLASS) Property Get Remarks
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Writen  : 04/26/1999 -- 12:21:25
' Inputs       : N/A
' Outputs      : String --
' Description  : Read-only public property
' *******************************************************
Public Property Get Remarks() As String
   Remarks = m_strRemarks
End Property

' *******************************************************
' Routine Name : (PUBLIC in CLASS) Property Get Path
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Writen  : 04/26/1999 -- 12:21:23
' Inputs       : N/A
' Outputs      : String --
' Description  : Read-only public property
' *******************************************************
Public Property Get Path() As String
   Path = m_strPath
End Property

' *******************************************************
' Routine Name : (PUBLIC in CLASS) Property Get Permissions
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Writen  : 04/26/1999 -- 12:21:20
' Inputs       : N/A
' Outputs      : enumSharePermissions --
' Description  : Read-only public property
' *******************************************************
Public Property Get Permissions() As enumSharePermissions
   Permissions = m_enmPermissions
End Property

' *******************************************************
' Routine Name : (PUBLIC in CLASS) Property Get ShareType
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Writen  : 04/26/1999 -- 12:21:17
' Inputs       : N/A
' Outputs      : enumShareType --
' Description  : Read-only public property
' *******************************************************
Public Property Get ShareType() As enumShareType
   ShareType = m_enmShareType
End Property

' *******************************************************
' Routine Name : (PUBLIC in CLASS) Property Get NumCurrConnections
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Writen  : 04/26/1999 -- 12:21:15
' Inputs       : N/A
' Outputs      : Long --
' Description  : Read-only public property
' *******************************************************
Public Property Get NumCurrConnections() As Long
   NumCurrConnections = m_lngCurrentConnections
End Property

' *******************************************************
' Routine Name : (PUBLIC in CLASS) Property Get NumMaxConnections
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Writen  : 04/26/1999 -- 12:21:12
' Inputs       : N/A
' Outputs      : Long --
' Description  : Read-only public property
' *******************************************************
Public Property Get NumMaxConnections() As Long
   NumMaxConnections = m_lngMaximumConnections
End Property
