VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "colFileEnum"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "SavedWithClassBuilder" ,"Yes"
Attribute VB_Ext_KEY = "Collection" ,"clsFileEnum"
Attribute VB_Ext_KEY = "Member0" ,"clsFileEnum"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
' ------------------------------------------------------
' colFileEnum.CLS
' Copyright (c) Slightly Tilted Software 1999
' By: L.J. Johnson       Date: 04-26-1999
' Comments: Collection class to manage collection of
'           File enumeration objects
' ------------------------------------------------------
Option Explicit
Option Base 1
Option Compare Text
DefLng A-Z

' --------------------------------------------
' Private variable to hold public property value
' --------------------------------------------
Private m_strServerName                As String

' --------------------------------------------
' Local variable to hold collection
' --------------------------------------------
Private m_colFileEnum As Collection

' *******************************************************
' Routine Name : (PRIVATE in CLASS) Sub Add
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Writen  : 04/26/1999 -- 12:25:44
' Inputs       : ByVal FileID:Long -
'              : ByVal FilePermissions:enumFilePermissions -
'              : ByVal NumLocks:Long   -
'              : ByVal PathName:String -
'              : ByVal UserName:String -
' Outputs      : N/A
' Description  : Don't have a public Add() method -- the
'              :     API call in FileEnum() which
'              :     is called by the Class_Initialize()
'              :     method will populate the info via
'              :     repeated calls to the Add() method
' *******************************************************
Private Sub Add(ByVal FileID As Long, _
                ByVal FilePermissions As enumFilePermissions, _
                ByVal NumLocks As Long, _
                ByVal PathName As String, _
                ByVal UserName As String)
   Dim p_objFileEnum                   As clsFileEnum
   
   Set p_objFileEnum = New clsFileEnum
   p_objFileEnum.Init xi_lngID:=FileID, _
                      xi_enmFilePermissions:=FilePermissions, _
                      xi_lngNumLocks:=NumLocks, _
                      xi_strPathName:=PathName, _
                      xi_strUserName:=UserName
   
   m_colFileEnum.Add p_objFileEnum

   Set p_objFileEnum = Nothing

End Sub

' *******************************************************
' Routine Name : (PUBLIC in CLASS) Property Get Item
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Writen  : 04/26/1999 -- 12:32:21
' Inputs       : vntIndexKey:Variant -
' Outputs      : clsConnectionEnum --
' Description  : Get a single item (object) with the
'              :     passed index value.
' *******************************************************
Public Property Get Item(IndexKey As Variant) As clsFileEnum
Attribute Item.VB_UserMemId = 0
   Set Item = m_colFileEnum(IndexKey)
End Property

' *******************************************************
' Routine Name : (PUBLIC in CLASS) Property Get Count
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Writen  : 04/26/1999 -- 12:32:19
' Inputs       : N/A
' Outputs      : Long -- Count of items
' Description  : Get a count of the number of items (objects)
'              :     in the collection.
' *******************************************************
Public Property Get Count() As Long
   Count = m_colFileEnum.Count
End Property

' *******************************************************
' Routine Name : (PUBLIC in CLASS) Property Get NewEnum
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Writen  : 04/26/1999 -- 12:32:15
' Inputs       : N/A
' Outputs      : IUnknown --
' Description  : Used to expose the For...Next syntax to
'              :     the calling program
' *******************************************************
Public Property Get NewEnum() As IUnknown
Attribute NewEnum.VB_UserMemId = -4
Attribute NewEnum.VB_MemberFlags = "40"
   Set NewEnum = m_colFileEnum.[_NewEnum]
End Property

' *******************************************************
' Routine Name : (PUBLIC in CLASS) Sub Init
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Writen  : 05/03/1999 -- 09:23:26
' Inputs       : ByVal ServerName:String -
' Outputs      : N/A
' Description  :
'              :
'              :
' Called By    : UI
' *******************************************************
Public Sub Init(ByVal ServerName As String)
   
   m_strServerName = ServerName
   FileEnum

End Sub

' *******************************************************
' Routine Name : (PRIVATE in CLASS) Sub Class_Initialize
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Writen  : 04/26/1999 -- 12:32:37
' Inputs       : N/A
' Outputs      : N/A
' Description  : Initialize the new collection and setup
'              :     the public properties via a call to
'              :     FileEnum
' *******************************************************
Private Sub Class_Initialize()
   Set m_colFileEnum = New Collection
End Sub

' *******************************************************
' Routine Name : (PRIVATE in CLASS) Sub Class_Terminate
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Writen  : 04/26/1999 -- 12:38:16
' Inputs       : N/A
' Outputs      : N/A
' Description  : Clean-up the collection
' *******************************************************
Private Sub Class_Terminate()
   Set m_colFileEnum = Nothing
End Sub

' *******************************************************
' Routine Name : (PRIVATE in SessionEnum) Sub FileEnum
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Writen  : 04/26/1999 -- 12:41:36
' Inputs       : N/A
' Outputs      : N/A
' Description  : Called by the Class_Initialize() method --
'              :     make the appropriate API call(s) and fill
'              :     in the collection via the Add() function
' *******************************************************
Private Sub FileEnum()
   Dim p_lngRtn                        As Long
   Dim p_abytServerName()              As Byte
   Dim p_abytBasePath()                As Byte
   Dim p_abytUserName()                As Byte
   Dim p_lngPtrBuffer                  As Long
   Dim p_lngEntriesRead                As Long
   Dim p_lngTotalEntries            As Long
   Dim p_lngResumeHwnd                 As Long
   Dim p_lngLoop                       As Long
   Dim p_lngID                         As Long
   Dim p_enmFilePermissions            As enumFilePermissions
   Dim p_lngNumLocks                   As Long
   Dim p_strPathName                   As String
   Dim p_strUserName                   As String
   Dim p_atypFileInfo()                As File_Info_3
   
   ' ------------------------------------------
   ' Initialize the variable(s)
   ' ------------------------------------------
   p_abytServerName = m_strServerName & Chr$(0)
   p_abytBasePath = Chr$(0)
   p_abytUserName = Chr$(0)
   
   ' ------------------------------------------
   ' Make appropriate API call and check for error
   ' ------------------------------------------
   p_lngRtn = NetFileEnum(ServerName:=p_abytServerName(0), _
                          BasePath:=p_abytBasePath(0), _
                          UserName:=p_abytUserName(0), _
                          Level:=3, _
                          BufPtr:=p_lngPtrBuffer, _
                          PrefMaxLen:=4096, _
                          EntriesRead:=p_lngEntriesRead, _
                          TotalLenEntries:=p_lngTotalEntries, _
                          ResumeHwnd:=p_lngResumeHwnd)
   If p_lngRtn <> 0 Then
      MsgBox "Had an error with NetFileEnum, " & CStr(p_lngRtn) & _
             " -- " & ReturnApiErrString(p_lngRtn), _
             Buttons:=vbInformation, _
             Title:=g_constMsgTitle
      Exit Sub
   End If
   
   ' ------------------------------------------
   ' Exit if no entries found
   ' ------------------------------------------
   If p_lngEntriesRead < 1 Then
      Exit Sub
   End If
   
   ' ------------------------------------------
   ' Redim the type array to hold this info
   ' ------------------------------------------
   ReDim p_atypFileInfo(0 To p_lngEntriesRead - 1)
         
   ' ------------------------------------------
   ' Copy the pointer to the buffer into the
   '     type array
   ' ------------------------------------------
   CopyMem p_atypFileInfo(0), _
           ByVal p_lngPtrBuffer, _
           Len(p_atypFileInfo(0)) * p_lngEntriesRead

   ' ------------------------------------------
   ' Fill-in the info needed to call the
   '     Add() method
   ' NOTE: We will always have +1 open pipe,
   '       since in making this call we create
   '       a pipe, "\PIPE\srvsvc"
   ' ------------------------------------------
   For p_lngLoop = 0 To p_lngEntriesRead - 1
      p_lngID = p_atypFileInfo(p_lngLoop).fi3_id
      p_enmFilePermissions = p_atypFileInfo(p_lngLoop).fi3_permissions
      p_lngNumLocks = p_atypFileInfo(p_lngLoop).fi3_num_locks
      p_strPathName = PointerToUnicodeStr(p_atypFileInfo(p_lngLoop).fi3_pathname)
      p_strUserName = PointerToUnicodeStr(p_atypFileInfo(p_lngLoop).fi3_username)
      
      Add FileID:=p_lngID, _
          FilePermissions:=p_enmFilePermissions, _
          NumLocks:=p_lngNumLocks, _
          PathName:=p_strPathName, _
          UserName:=p_strUserName
   Next p_lngLoop
   
   ' ------------------------------------------
   ' Clean-up the buffer
   ' ------------------------------------------
   If p_lngPtrBuffer <> 0 Then
      NetApiBufferFree p_lngPtrBuffer
   End If
   
End Sub

' *******************************************************
' Routine Name : (PUBLIC in CLASS) Sub CloseFile
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Writen  : 04/26/1999 -- 12:44:33
' Inputs       : ByVal FilePtr:Long          -
'              : ByVal CloseOnServer:String  -
'              : ByVal CloseFileName:String  -
' Outputs      : N/A
' Description  : Passed the pointer to the file, and the
'              :     name of the server (can be blank),
'              :     close this network-opened file
'              : Note: The filename passed only for the
'              :     msgbox function.
' *******************************************************
Public Sub CloseFile(ByVal FilePtr As Long, _
                     ByVal CloseOnServer As String, _
                     ByVal CloseFileName As String)
   Dim p_lngRtn                        As Long
   Dim p_abytServerName()              As Byte
   
   ' ------------------------------------------
   ' Initialize the variable(s)
   ' ------------------------------------------
   p_abytServerName = Trim$(CloseOnServer) & Chr$(0)
   
   ' ------------------------------------------
   ' Make appropriate API call and check for error
   ' ------------------------------------------
   p_lngRtn = NetFileClose(ServerName:=p_abytServerName(0), _
                           PtrFile:=FilePtr)
   If p_lngRtn <> NERR_Success Then
      MsgBox "Error closing the file, " & CloseFileName & _
             " -- " & ReturnApiErrString(p_lngRtn), _
             Buttons:=vbInformation, _
             Title:=g_constMsgTitle
   End If

End Sub
