VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "colShareEnum"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "SavedWithClassBuilder" ,"Yes"
Attribute VB_Ext_KEY = "Collection" ,"clsShareEnum"
Attribute VB_Ext_KEY = "Member0" ,"clsShareEnum"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Attribute VB_Ext_KEY = "Member1" ,"colConnectionEnum"
' ------------------------------------------------------
' colShareEnum.CLS
' Copyright (c) Slightly Tilted Software 1999
' By: L.J. Johnson       Date: 04-26-1999
' Comments: Collection class to manage collection of
'           Share enumeration objects
' ------------------------------------------------------
Option Explicit
Option Base 1
Option Compare Text
DefLng A-Z

' --------------------------------------------
' Private variable to hold public property value
' --------------------------------------------
Private m_strServerName                As String

' --------------------------------------------
' Local variable to hold collection
' --------------------------------------------
Private m_colShareEnum As Collection

' *******************************************************
' Routine Name : (PRIVATE in CLASS) Sub Add
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Writen  : 04/26/1999 -- 12:30:07
' Inputs       : ByVal ShareName:String        -
'              : ByVal Remarks:String          -
'              : ByVal Path:String             -
'              : ByVal MaximumConnections:Long -
'              : ByVal CurrentConnections:Long -
'              : ByVal ShareType:enumShareType -
'              : ByVal Permissions:enumSharePermissions -
' Outputs      : N/A
' Description  : Don't have a public Add() method -- the
'              :     API call in ShareEnum() -- which
'              :     is called by the Class_Initialize method
'              :     --  will populate the info via repeated
'              :     calls to the Add() method
' *******************************************************
Private Sub Add(ByVal ShareName As String, _
                ByVal Remarks As String, _
                ByVal Path As String, _
                ByVal MaximumConnections As Long, _
                ByVal CurrentConnections As Long, _
                ByVal ShareType As enumShareType, _
                ByVal Permissions As enumSharePermissions)
   Dim p_objShareEnum                  As clsShareEnum
   
   Set p_objShareEnum = New clsShareEnum
   p_objShareEnum.Init xi_strShareName:=ShareName, _
                       xi_strRemarks:=Remarks, _
                       xi_strPath:=Path, _
                       xi_lngMaximumConnections:=MaximumConnections, _
                       xi_lngCurrentConnections:=CurrentConnections, _
                       xi_enmShareType:=ShareType, _
                       xi_enmPermissions:=Permissions
   
   m_colShareEnum.Add p_objShareEnum

   Set p_objShareEnum = Nothing

End Sub

' *******************************************************
' Routine Name : (PUBLIC in CLASS) Property Get Item
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Writen  : 04/26/1999 -- 12:32:21
' Inputs       : vntIndexKey:Variant -
' Outputs      : clsConnectionEnum --
' Description  : Get a single item (object) with the
'              :     passed index value.
' *******************************************************
Public Property Get Item(vntIndexKey As Variant) As clsShareEnum
Attribute Item.VB_UserMemId = 0
   Set Item = m_colShareEnum(vntIndexKey)
End Property

' *******************************************************
' Routine Name : (PUBLIC in CLASS) Property Get Count
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Writen  : 04/26/1999 -- 12:32:19
' Inputs       : N/A
' Outputs      : Long -- Count of items
' Description  : Get a count of the number of items (objects)
'              :     in the collection.
' *******************************************************
Public Property Get Count() As Long
   Count = m_colShareEnum.Count
End Property

' *******************************************************
' Routine Name : (PUBLIC in CLASS) Property Get NewEnum
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Writen  : 04/26/1999 -- 12:32:15
' Inputs       : N/A
' Outputs      : IUnknown --
' Description  : Used to expose the For...Next syntax to
'              :     the calling program
' *******************************************************
Public Property Get NewEnum() As IUnknown
Attribute NewEnum.VB_UserMemId = -4
Attribute NewEnum.VB_MemberFlags = "40"
   Set NewEnum = m_colShareEnum.[_NewEnum]
End Property

' *******************************************************
' Routine Name : (PUBLIC in CLASS) Sub Init
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Writen  : 05/03/1999 -- 09:23:26
' Inputs       : ByVal ServerName:String -
' Outputs      : N/A
' Description  :
'              :
'              :
' Called By    : UI
' *******************************************************
Public Sub Init(ByVal ServerName As String)
   
   m_strServerName = ServerName
   ShareEnum

End Sub

' *******************************************************
' Routine Name : (PRIVATE in CLASS) Sub Class_Initialize
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Writen  : 04/26/1999 -- 12:32:37
' Inputs       : N/A
' Outputs      : N/A
' Description  : Initialize the new collection and setup
'              :     the public properties via a call to
'              :     ShareEnum
' *******************************************************
Private Sub Class_Initialize()
    Set m_colShareEnum = New Collection
End Sub

' *******************************************************
' Routine Name : (PRIVATE in CLASS) Sub Class_Terminate
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Writen  : 04/26/1999 -- 12:38:16
' Inputs       : N/A
' Outputs      : N/A
' Description  : Clean-up the collection
' *******************************************************
Private Sub Class_Terminate()
   Set m_colShareEnum = Nothing
End Sub

' *******************************************************
' Routine Name : (PRIVATE in CLASS) Sub ShareEnum
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Writen  : 04/26/1999 -- 12:43:42
' Inputs       : N/A
' Outputs      : N/A
' Description  : Called by the Class_Initialize() method --
'              :     make the appropriate API call(s) and fill
'              :     in the collection via the Add() function
' *******************************************************
Private Sub ShareEnum()
   Dim p_lngRtn                        As Long
   Dim p_abytServerName()              As Byte
   Dim p_lngPtrBuffer                  As Long
   Dim p_lngEntriesRead                As Long
   Dim p_lngTotalEntries               As Long
   Dim p_lngResumeHwnd                 As Long
   Dim p_lngLoop                       As Long
   Dim p_strShareName                  As String
   Dim p_strRemarks                    As String
   Dim p_strPath                       As String
   Dim p_lngMaxConnections             As Long
   Dim p_lngNumCurrConnections         As Long
   Dim p_enmShareType                  As enumShareType
   Dim p_enmPermissions                As enumSharePermissions
   Dim p_atypShareInfo()               As Share_Info_2
   
   ' ------------------------------------------
   ' Initialize the variable(s)
   ' ------------------------------------------
   p_abytServerName = m_strServerName & Chr$(0)
   
   ' ------------------------------------------
   ' Make appropriate API call and check for error
   ' ------------------------------------------
   p_lngRtn = NetShareEnum(ServerName:=p_abytServerName(0), _
                           Level:=2, _
                           Buffer:=p_lngPtrBuffer, _
                           PreMaxLen:=4096&, _
                           EntriesRead:=p_lngEntriesRead, _
                           TotalEntries:=p_lngTotalEntries, _
                           Resume_Handle:=p_lngResumeHwnd)
                           
   If p_lngRtn <> NERR_Success Then
      MsgBox "Had an error with NetShareEnum, " & CStr(p_lngRtn) & _
             " -- " & ReturnApiErrString(p_lngRtn), _
             Buttons:=vbInformation, _
             Title:=g_constMsgTitle
      Exit Sub
   End If
   
   ' ------------------------------------------
   ' Exit if no entries found
   ' ------------------------------------------
   If p_lngEntriesRead < 1 Then
      Exit Sub
   End If
   
   ' ------------------------------------------
   ' Redim the type array to hold this info
   ' ------------------------------------------
   ReDim p_atypShareInfo(0 To p_lngEntriesRead - 1)

   ' ------------------------------------------
   ' Copy the pointer to the buffer into the
   '     type array
   ' ------------------------------------------
   CopyMem p_atypShareInfo(0), _
           ByVal p_lngPtrBuffer, _
           Len(p_atypShareInfo(0)) * p_lngEntriesRead

   ' ------------------------------------------
   ' Fill-in the info needed to call the
   '     Add() method
   ' ------------------------------------------
   For p_lngLoop = 0 To p_lngEntriesRead - 1
      p_strShareName = PointerToUnicodeStr(p_atypShareInfo(p_lngLoop).shi2_netname)
      p_strRemarks = PointerToUnicodeStr(p_atypShareInfo(p_lngLoop).shi2_remark)
      p_strPath = PointerToUnicodeStr(p_atypShareInfo(p_lngLoop).shi2_path)
      p_lngMaxConnections = p_atypShareInfo(p_lngLoop).shi2_max_uses
      p_lngNumCurrConnections = p_atypShareInfo(p_lngLoop).shi2_current_uses
      p_enmShareType = p_atypShareInfo(p_lngLoop).shi2_type
      p_enmPermissions = p_atypShareInfo(p_lngLoop).shi2_permissions
     
      Add ShareName:=p_strShareName, _
          Remarks:=p_strRemarks, _
          Path:=p_strPath, _
          MaximumConnections:=p_lngMaxConnections, _
          CurrentConnections:=p_lngNumCurrConnections, _
          ShareType:=p_enmShareType, _
          Permissions:=p_enmPermissions
   Next p_lngLoop
   
   ' ------------------------------------------
   ' Clean-up the buffer
   ' ------------------------------------------
   If p_lngPtrBuffer <> 0 Then
      NetApiBufferFree p_lngPtrBuffer
   End If
   
End Sub
